

Imports System.Reflection.MethodBase
Imports FarPoint.Win.Spread
Imports System.Drawing

Public Class Form1


    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        Const Row As Integer = 50
        Const Col As Integer = 0

        Dim a As Object = New TargetObject
        With Me.FpSpread1_Sheet1
            .Cells(Row, Col).Value = a
            Dim panel As New ReportPanel
            .Cells(Row, Col).CellType = New ReportCellType(panel)
            .Cells(Row, Col).ColumnSpan = 6
            .Cells(Row, Col).RowSpan = 10
        End With
    End Sub
End Class

Public Class TargetObject
    Public Sub New()
    End Sub

End Class


Public Class ReportCellType
    Inherits FarPoint.Win.Spread.CellType.ImageCellType

    Private mPanel As ReportPanel = Nothing
    Private mPanelImage As Bitmap = Nothing

    Public Sub New(ByVal panel As ReportPanel)
        mPanel = panel
        mPanel.Visible = False
    End Sub

    Public Overrides Sub PaintCell(ByVal g As System.Drawing.Graphics, ByVal r As System.Drawing.Rectangle, ByVal appearance As FarPoint.Win.Spread.Appearance, ByVal value As Object, ByVal isSelected As Boolean, ByVal isLocked As Boolean, ByVal zoomFactor As Single)
        Dim nr As System.Drawing.Rectangle = r
        If mPanelImage Is Nothing OrElse r.Size <> mPanel.Size Then
            mPanel.Size = r.Size
            mPanel.Reset()
            mPanel.Rend(value)
            mPanel.Visible = True

            mPanelImage = New Bitmap(r.Size.Width, r.Size.Height, Imaging.PixelFormat.Format64bppPArgb)

            nr = New Rectangle(New Point(0, 0), r.Size)
            mPanel.DrawToBitmap(mPanelImage, nr)

            g.FillRectangle(New SolidBrush(appearance.BackColor), nr)
        End If
        mPanel.Visible = False
        MyBase.PaintCell(g, nr, appearance, mPanelImage, isSelected, isLocked, zoomFactor)
    End Sub
End Class

Public Class ReportPanel
    Inherits Panel

    Private mValue As Object = Nothing
    Public Sub New()

    End Sub

    Public Sub Reset()
        mValue = Nothing
    End Sub
    Public Sub Rend(ByVal value As Object)
        If value IsNot Nothing Then
            MyBase.BackColor = Color.Red
            mValue = value
        End If
    End Sub

End Class